Bug 1288577 - libstdc++: backport fix for missing "cxx11" abi_tag in special modes
libstdc++: backport fix for missing "cxx11" abi_tag in special modes
Status: CLOSED EOL
Product: Fedora
Classification: Fedora
Component: gcc (Show other bugs)
23
Unspecified Unspecified
unspecified Severity unspecified
: ---
: ---
Assigned To: Jakub Jelinek
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2015-12-04 11:09 EST by Stephan Bergmann
Modified: 2016-12-20 11:37 EST (History)
6 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2016-12-20 11:37:49 EST
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Stephan Bergmann 2015-12-04 11:09:30 EST
The one-line patch <https://gcc.gnu.org/viewcvs/gcc?view=revision&revision=226022> "Fix abi_tag in special modes" is only present in upstream master, not in F23 libstdc++-devel-5.1.1-4.fc23.x86_64.

With a fix for bug 1282645 forthcoming, it would be great if that patch could be backported to F23 libstdc++, so that Clang does not error out on the empty abi_tag attribute.
Comment 1 Jakub Jelinek 2015-12-04 11:30:44 EST
Jonathan/Jason, was it intentional that it only went into trunk and not into gcc-5-branch?  I'll probably do another set of rpms Monday or so, as GCC 5.3 has been released, wondering if it first should go upstream, or should go to 5.3-RH only, or too risky for backporting.
Comment 2 Jason Merrill 2015-12-04 12:08:43 EST
I imagine I thought it wasn't important to go into 5, but I'll check it in there now.
Comment 3 Jonathan Wakely 2015-12-04 12:12:29 EST
I think that could be backported to gcc-5-branch, otherwise this file generates different symbols on trunk and the branch:

#define _GLIBCXX_DEBUG
#include <list>
auto f() { return &std::list<int>::size; }

It's hard to come up with a case where it really matters though, because Debug Mode is not ABI compatible, and I think you'd have to refer to some non-public implementation detail to see the effect anyway (according to the standard the program above is not required to even compile, for example).

Clang giving an error is just a Clang bug, the argument on the attribute is optional.
Comment 4 Stephan Bergmann 2015-12-06 08:42:03 EST
(In reply to Jonathan Wakely from comment #3)
> Clang giving an error is just a Clang bug, the argument on the attribute is
> optional.

Is it really optional?  See <https://gcc.gnu.org/bugzilla/show_bug.cgi?id=68257> "Reject empty abi_tag attribute on inline namespace."  But maybe I misinterpreted what you meant with "That seems like a bug."
Comment 5 Jonathan Wakely 2015-12-07 05:38:40 EST
I'm not sure what I meant now. Either I was just mistaken, or I thought that  __abi_tag__() should be rejected. Using just __abi_tag__ is definitely intended to work (as Jakub commented on the upstream bug).
Comment 6 Fedora End Of Life 2016-11-24 08:58:19 EST
This message is a reminder that Fedora 23 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 23. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as EOL if it remains open with a Fedora  'version'
of '23'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 23 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.
Comment 7 Fedora End Of Life 2016-12-20 11:37:49 EST
Fedora 23 changed to end-of-life (EOL) status on 2016-12-20. Fedora 23 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.